extern int Pass = 1; // 1 .. 3
extern int BarOffset = 20;

extern string Tmp1 = "-----------";

extern int Smoke1 = 75; // 0 .. DEFAULT

// 0 .. 2 * DEFAULT
extern int X11 = 100;
extern int X21 = 100;
extern int X31 = 100;
extern int X41 = 100;

extern string Tmp2 = "-----------";

extern int Smoke2 = 75; // 0 .. DEFAULT

// 0 .. 2 * DEFAULT
extern int X12 = 100;
extern int X22 = 100;
extern int X32 = 100;
extern int X42 = 100;

extern double Lots = 1;

#define AMOUNT 4
#define VARIANTS 2
#define DEFAULT 100

double Inputs[AMOUNT][VARIANTS], Smokes[VARIANTS];
int Vars[VARIANTS];

void init()
{
  int i, j;
  double Sum[VARIANTS];

  ArrayInitialize(Sum, 0);

  Inputs[0][0] = X11;
  Inputs[1][0] = X21;
  Inputs[2][0] = X31;
  Inputs[3][0] = X41;

  Inputs[0][1] = X12;
  Inputs[1][1] = X22;
  Inputs[2][1] = X32;
  Inputs[3][1] = X42;

  Smokes[0] = Smoke1;
  Smokes[1] = Smoke2;

  for (i = 0; i < AMOUNT; i++)
    for (j = 0; j < VARIANTS; j++)
    {
      Inputs[i][j] -= DEFAULT;
      Sum[j] += MathAbs(Inputs[i][j]);
    }

  for (j = 0; j < VARIANTS; j++)
  {
    if (Sum[j] != 0)
      for (i = 0; i < AMOUNT; i++)
        Inputs[i][j] /= Sum[j];
    else
      for (i = 0; i < AMOUNT; i++)
        Inputs[i][j] = 1 / AMOUNT;

    Smokes[j] /= DEFAULT;
  }

  Pass--;

  return;
}

double GetPrice( int Offset )
{
  return(Open[Offset]);
}

int iIF( bool Condition, int Num1, int Num2 )
{
  if (Condition)
    return(Num1);

  return(Num2);
}

int Perceptron( int Pass )
{
  int Offset = 0;
  double Tmp, Res = 0, Max = 0;

  for (int i = 0; i < AMOUNT; i++)
  {
    Tmp = GetPrice(Offset);
    Offset += BarOffset;
    Tmp /= GetPrice(Offset);
    Tmp -= 1;

    Res += Inputs[i][Pass] * Tmp;

    if (Tmp < 0)
      Tmp = -Tmp;

    if (Tmp > Max)
      Max = Tmp;
  }

  if (Max != 0)
    Res /= Max; // -1 .. +1

  if (MathAbs(Res) < Smokes[Pass])
    Res = 0;
  else
    Res = iIF(Res > 0, 1, -1);

  return(Res);
}

int GetSignal( int Pass )
{
  int PRes1, PRes2;

  if (Pass < VARIANTS)
    return(Perceptron(Pass));

  PRes1 = Perceptron(0);
  PRes2 = Perceptron(1);

  if (PRes1 == PRes2)
    return(PRes1);

  return(0);
}

void ClosePosition( int& Ticket )
{
  if (Ticket > 0)
    OrderClose(Ticket, Lots, Bid, 0);
  else if (Ticket < 0)
    OrderClose(-Ticket, Lots, Ask, 0);

  Ticket = 0;

  return;
}

void OpenPosition( int Type, int& Ticket )
{
  double Price;

  switch (Type)
  {
    case OP_BUY:
      if (Ticket < 0)
        ClosePosition(Ticket);

      if (Ticket == 0)
        Ticket = OrderSend(Symbol(), OP_BUY, Lots, Ask, 0, 0, 0);

      break;
    case OP_SELL:
      if (Ticket > 0)
        ClosePosition(Ticket);

      if (Ticket == 0)
        Ticket = -OrderSend(Symbol(), OP_SELL, Lots, Bid, 0, 0, 0);
  }

  return;
}

void start()
{
  static int PrevTime = 0;
  static int Ticket = 0;
  int Signal;

  if (PrevTime == Time[0])
    return;

  PrevTime = Time[0];

  Signal = GetSignal(Pass);

  switch (Signal)
  {
    case 1:
      OpenPosition(OP_BUY, Ticket);
      break;
    case -1:
      OpenPosition(OP_SELL, Ticket);
      break;
    case 0:
      ClosePosition(Ticket);
  }

  return;
}